#ifndef SHOWPLAYER_H
#define SHOWPLAYER_H

#include <vector>
#include <string>

#include <QDialog>

#include "defines.h"
#include "cuetrackwidget.h"
#include "cuetracklistwidget.h"
#include "trackdialog.h"
#include "ui_showplayer.h"

namespace Ui {
    class ShowPlayer;
}

class ShowPlayer : public QDialog
{
    Q_OBJECT

public:
    explicit ShowPlayer(QWidget *parent = nullptr);
    ~ShowPlayer();

private:
    Ui::ShowPlayer *ui;
    CueTrackListWidget *cueListWidget; // Widget para mostrar los tracks
	size_t currentTrackIndex;
    Status currentStatus = Status::Iddle;
    size_t filesLoaded = 0;
	int layersUsed[MAX_LAYERS] = { -1 };

    QWidget *createHeader();

    void updateTrackStateInEngine(size_t index, int layer) {
            CueTrackWidget *track = cueListWidget->getTrackAtIndex(index);
            emit uiSliderChanged(layer, Slider::Volume, track->getVolume());
            emit uiSliderChanged(layer, Slider::Pan, track->getPan());
            emit uiSliderChanged(layer, Slider::Pitch, track->getPitch());
            emit uiSliderChanged(layer, Slider::Bus1, track->getBus1());
            emit uiSliderChanged(layer, Slider::Bus2, track->getBus2());
    };

private slots:
    void onAddTrack();
    void go();
    //void stop();
    //void nextTrack();
    //void goToTrack(size_t i);

signals:
    void uiPlaybackChanged(int layer, Status s);
    void uiSliderChanged(int layer, Slider s, int vol);
    void uiLoadMedia(int layer, QString s);
};

#endif // SHOWPLAYER_H
